// Define the pins for the rotary encoder
#define CLK_PIN A0
#define DT_PIN A3
#define SW_PIN A1

// Variables to store the current and previous state of the encoder
// volatile int lastEncoded = 0;
// volatile long encoderValue = 0;

int counter = 0;
int CLK_state;
int CLK_laststate;


void setup() {
  // Set encoder pins as inputs
  pinMode(CLK_PIN, INPUT);
  pinMode(DT_PIN, INPUT);
  pinMode(SW_PIN, INPUT_PULLUP); // Internal pull-up resistor for the push button
  
  
  // Initialize serial communication
  Serial.begin(9600);
  CLK_laststate = digitalRead(CLK_PIN);   
} 

 void loop() { 
  CLK_state = digitalRead(CLK_PIN); // Reads the "current" state of the outputA
  // If the previous and the current state of the outputA are different, that means a Pulse has occured

  if (digitalRead(SW_PIN) == LOW) {
    Serial.println("Button Pressed!");
    // Your button action code here
    // For example: toggle a LED
    // digitalWrite(LED_PIN, !digitalRead(LED_PIN));
    delay(250); // Debouncing delay   
  }
  
  
   if (CLK_state != CLK_laststate){     
     // If the outputB state is different to the outputA state, that means the encoder is rotating clockwise
     if (digitalRead(DT_PIN) != CLK_state) { 
       counter ++;
     } else {
       counter --;
     }
     Serial.print("");
     Serial.println(counter);
   } 
   CLK_laststate = CLK_state; // Updates the previous state of the outputA with the current state
  
  if (counter > 40 || counter <-40){
    counter = 0;
  }
 
}
